<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <div
            class="w-full text-white flex justify-start space-x-2 items-center py-3"
        >
            <div class="w-12 cursor-pointer pl-4">
                <font-awesome-icon
                    icon="fa-solid fa-arrow-left"
                    size="2x"
                    @click="$router.go(-1)"
                />
            </div>
            <div class="flex-1 uppercase font-black">
                {{ $t('buy_in') }}: {{ plan.code }}
            </div>
        </div>
        <div
            class="flex justify-between px-2 text-gray-400"
        >
            <div class="flex-1 flex justify-start space-x-4">
                <div class="pl-6">
                    <font-awesome-icon
                        icon="fa-solid fa-wallet"
                        size="2x"
                    />
                </div>
                <div
                    class="flex-1"
                >
                    <div class="capitalize">{{ $t('available_funds') }}:</div>
                    <div
                        class="mt-5 flex flex-col justify-start text-xs"
                    >
                        <div class="text-green-600">{{ $t('credit_1_short') }}: $ {{ $helper.fundFormat($user.credit_1) }}</div>
                        <div>{{ $t('credit_2_short') }}: $ {{ $helper.fundFormat($user.credit_2) }}</div>
                    </div>
                </div>
            </div>
            <div class="font-bold">
                <span class="mr-5">$</span> {{ $helper.fundFormat($totalAvailableFunds) }}
            </div>
        </div>
        <div
            class="mt-6 mb-3 px-7"
        >
            <form-input
                ref="investAmountRef"
                v-model="investAmount"
                name="invest_amount"
                hide-label dark fund dollar-sign
                size="lg"
                type="number"
                :placeholder="$t('buy_in_amount')"
                :append-button="true"
                :append-button-text="$t('max')"
                :append-button-set-value="maxInvestAmount"
                @update:model-value="onInvestAmountUpdate"
            />
            <div class="mt-2 px-3 leading-tight">
                <div
                    v-if="minInvest"
                    class="capitalize"
                >
                    {{ $t('minimum_investment') }}: $ {{ $helper.fundFormat(minInvest, 0) }}
                </div>
                <div class="capitalize">{{ $t('denominator') }}: $ {{ $helper.fundFormat(denominator, 0) }}</div>
            </div>
        </div>
        <div
            class="border-b border-gray-400 pt-2 mb-2"
        />
        <div
            class="px-3"
        >
            <div class="pl-2 capitalize mt-3">{{ $t('wallet_allocation') }}</div>
            <div
                class="my-3"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div
                        class="w-32"
                    >
                        <div
                            class="input-box mt-1 text-center"
                        >
                            {{ $t('credit_1_short') }}
                        </div>
                    </div>
                    <div
                        class="flex-1"
                    >
                        <form-input
                            ref="credit1Ref"
                            v-model="credit1Amount"
                            name="credit_1_amount"
                            hide-label dark fund dollar-sign
                            size="lg"
                            type="number"
                            :placeholder="'-'"
                            :append-button="true"
                            :append-button-text="$t('max')"
                            @append-button-callback="onCredit1MaxButtonClick"
                            @blur="updateCredit1Used"
                        />
                        <div class="text-xs capitalize pl-3">
                            {{ $t('balance') }}: ${{ $helper.fundFormat($user.credit_1) }}
                        </div>
                    </div>
                </div>
                <div
                    class="flex justify-start space-x-3 mt-2"
                >
                    <div
                        class="w-32"
                    >
                        <div
                            class="input-box mt-1 text-center"
                        >
                            {{ $t('credit_2_short') }}
                        </div>
                    </div>
                    <div
                        class="flex-1"
                    >
                        <form-input
                            ref="credit2Ref"
                            v-model="credit2Amount"
                            name="credit_2_amount"
                            hide-label dark fund dollar-sign
                            size="lg"
                            type="number"
                            :placeholder="'-'"
                            :append-button="true"
                            :append-button-text="$t('max')"
                            @append-button-callback="onCredit2MaxButtonClick"
                            @blur="updateCredit2Used"
                        />
                        <div class="text-xs capitalize pl-3">
                            {{ $t('balance') }}: ${{ $helper.fundFormat($user.credit_2) }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div
            v-if="investAmount"
            class="my-6 px-3"
        >
            <div
                class="bg-gray-800 text-white px-4 py-3 rounded-lg"
            >
                <div
                    class="flex justify-start leading-tight capitalize"
                >
                    <div class="flex-1">
                        {{ $t('buy_in_amount') }}
                    </div>
                    <div class="w-6">$</div>
                    <div class="w-24 overflow-y-scroll text-right">
                        {{ $helper.fundFormat(investAmount, 0) }}
                    </div>
                </div>
                <div
                    class="flex justify-start leading-tight capitalize"
                    :class="{
                        'text-red-600': credit1Amount > 0,
                        'text-gray-400': !credit1Amount
                    }"
                >
                    <div class="flex-1">
                        {{ $t('credit_1_short') }}
                    </div>
                    <div class="w-6">$</div>
                    <div class="w-24 overflow-y-scroll text-right">
                        <template
                            v-if="credit1Amount > 0"
                        >
                            - {{ $helper.fundFormat(credit1Amount, 0) }}
                        </template>
                        <template
                            v-else
                        >
                            0
                        </template>
                    </div>
                </div>
                <div
                    class="flex justify-start leading-tight capitalize"
                    :class="{
                        'text-red-600': credit2Amount > 0,
                        'text-gray-400': !credit2Amount
                    }"
                >
                    <div class="flex-1">
                        {{ $t('credit_2_short') }}
                    </div>
                    <div class="w-6">$</div>
                    <div class="w-24 overflow-y-scroll text-right">
                        <template
                            v-if="credit2Amount > 0"
                        >
                            - {{ $helper.fundFormat(credit2Amount, 0) }}
                        </template>
                        <template
                            v-else
                        >
                            0
                        </template>
                    </div>
                </div>
            </div>
        </div>
        <div>
            <auto-button
                block
                rounded
                :busy="!canSubmitForm"
                :disabled="!canSubmitForm"
                class="tracking-wider text-2xl"
                @click="password2Prompt = true"
            >
                {{ $t('buy_in') }}
            </auto-button>
        </div>
        <password2-prompt
            v-if="password2Prompt"
            @confirm="onPassword2Confirmed"
            @close="password2Prompt = false"
        />
    </div>
</template>

<script setup>
import {computed, inject, nextTick, onMounted, ref, watch} from "vue";
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";
import {useSettingStore} from "~/stores/setting.js";
import {useRoute, useRouter} from "vue-router";
import AutoButton from "~/components/button/auto-button.vue";
import axios from "axios";
import {useUserStore} from "~/stores/user.js";
import FormInput from "~/components/form/form-input.vue";
import BigNumber from "bignumber.js";
import Password2Prompt from "~/components/password2-prompt.vue";

const pageReady = ref(false);
const $route = useRoute();
const $router = useRouter();
const $userStore = useUserStore();
const $helper = inject('$helper');

const busy = ref(false);
const plan = ref('');
const password2 = ref('');
const password2Prompt = ref(false);
const investAmount = ref('');
const investAmountRef = ref();
const credit1Amount = ref('');
const credit1Ref = ref();
const credit2Amount = ref('');
const credit2Ref = ref();
const minInvest = ref(new BigNumber(0));

const $user = computed(() => {
    return $userStore.account;
});
const $totalAvailableFunds = computed(() => {
    return $userStore.creditTotalValue;
});
const maxInvestAmount = computed(() => {
    return new BigNumber(Math.floor(availableTotalCreditForInvest.value / denominator.value)).times(100);
});
const availableTotalCreditForInvest = computed(() => {
    if ($totalAvailableFunds.value.lt(minInvest.value)) return new BigNumber(0);
    return new BigNumber(Math.floor(new BigNumber($totalAvailableFunds.value)));
});
const availableCredit1ForInvest = computed(() => {
    let t = new BigNumber($user.value.credit_1);
    // if (t.lt(minInvest.value)) return new BigNumber(0);
    return new BigNumber(Math.floor(new BigNumber(t)));
});
const availableCredit2ForInvest = computed(() => {
    let t = new BigNumber($user.value.credit_2);
    // if (t.lt(minInvest.value)) return new BigNumber(0);
    return new BigNumber(Math.floor(new BigNumber(t)));
});
const denominator = computed(() => {
    if (!plan.value) return 1;
    else return plan.value.setting.investment_multiplication_of_amount;
});
const canSubmitForm = computed(() => {
    try {
        if (busy.value) return false;
        if (!investAmount.value) return false;

        let t = new BigNumber(investAmount.value);
        let c1 = new BigNumber(credit1Amount.value || 0);
        let c2 = new BigNumber(credit2Amount.value || 0);

        return t.eq(c1.plus(c2));
    } catch (e) {
        return false;
    }
})

const syncNumberToForm = async () => {
    await nextTick(() => {
        if (credit1Amount.value instanceof BigNumber) {
            credit1Ref.value.forceUpdateValue(credit1Amount.value.toNumber());
        } else {
            credit1Ref.value.forceUpdateValue(credit1Amount.value);
        }

        if (credit2Amount.value instanceof BigNumber) {
            credit2Ref.value.forceUpdateValue(credit2Amount.value.toNumber());
        } else {
            credit2Ref.value.forceUpdateValue(credit2Amount.value);
        }
    });
};

watch(investAmount, async (newValue, oldValue) => {
    await autoSetCredit2Amount(true);
    await autoSetCredit1Amount();
    await syncNumberToForm();
});

const onCredit1MaxButtonClick = async () => {
    await nextTick(async () => {
        let t = new BigNumber(investAmount.value);
        if (t.gt(0) && t.gte(minInvest.value)) {
            let c1 = new BigNumber(availableCredit1ForInvest.value);
            if (c1.gte(t)) {
                credit1Amount.value = t.toNumber().toFixed(0);
            } else {
                credit1Amount.value = c1.toNumber().toFixed(0);
            }
        } else {
            credit1Amount.value = '';
        }

        await autoSetCredit2Amount();
        await syncNumberToForm();
    });
};
const updateCredit1Used = async () => {
    let t = new BigNumber(investAmount.value);
    if (t.gt(0) && t.gte(minInvest.value) && availableTotalCreditForInvest.value.gte(t)) {
        let n = new BigNumber(credit1Amount.value || 0);
        if (n.gte(denominator.value)) {
            credit1Amount.value = new BigNumber(Math.floor(n.div(denominator.value))).times(100);

            if (credit1Amount.value.gt(t)) {
                credit1Amount.value = t;
            }
        } else {
            credit1Amount.value = '';
        }

        await autoSetCredit2Amount();
    } else {
        credit1Amount.value = '';
        credit2Amount.value = '';
    }

    await syncNumberToForm();
};
const onCredit2MaxButtonClick = async () => {
    let t = new BigNumber(investAmount.value);
    if (t.gt(0) && t.gte(minInvest.value) && availableTotalCreditForInvest.value.gte(t)) {
        if (availableCredit2ForInvest.value.gte(t)) {
            credit2Amount.value = t;
        } else {
            credit2Amount.value = availableCredit2ForInvest.value;
        }
    } else {
        credit2Amount.value = '';
    }

    await autoSetCredit1Amount();
    await syncNumberToForm();
};
const updateCredit2Used = async () => {
    let t = new BigNumber(investAmount.value);
    if (t.gt(0) && t.gte(minInvest.value) && availableTotalCreditForInvest.value.gte(t)) {
        let n = new BigNumber(credit2Amount.value || 0);
        if (n.gte(denominator.value)) {
            credit2Amount.value = new BigNumber(Math.floor(n.div(denominator.value))).times(100);
            if (credit2Amount.value.gt(t)) {
                credit2Amount.value = t;
            }
        } else {
            credit2Amount.value = '';
        }

        await autoSetCredit1Amount();
    } else {
        credit1Amount.value = '';
        credit2Amount.value = '';
    }

    await syncNumberToForm();
};

const autoSetCredit1Amount = async (forceful = false) => {
    let t = new BigNumber(investAmount.value);
    let used = new BigNumber(credit2Amount.value);
    if (forceful) {
        used = new BigNumber(0);
    }
    if (t.gt(0) && t.gte(minInvest.value) && availableTotalCreditForInvest.value.gte(t)) {
        let b = t.minus(used);
        if (b.gt(0)) {
            let a = new BigNumber(availableCredit1ForInvest.value);
            if (b.gte(a)) {
                credit1Amount.value = a;
            } else {
                credit1Amount.value = b;
            }
        } else {
            credit1Amount.value = '';
        }
    } else {
        credit1Amount.value = '';
    }
};
const autoSetCredit2Amount = async (forceful = false) => {
    let t = new BigNumber(investAmount.value);
    let used = new BigNumber(credit1Amount.value);
    if (forceful) {
        used = new BigNumber(0);
    }
    if (t.gt(0) && t.gte(minInvest.value) && availableTotalCreditForInvest.value.gte(t)) {
        let b = t.minus(used);
        if (b.gt(0)) {
            let a = new BigNumber(availableCredit2ForInvest.value);
            if (b.gte(a)) {
                credit2Amount.value = a;
            } else {
                credit2Amount.value = b;
            }
        } else {
            credit2Amount.value = '';
        }
    } else {
        credit2Amount.value = '';
    }
};

const onInvestAmountUpdate = async () => {
    await nextTick(async () => {
        let i = new BigNumber(investAmount.value);
        if (i.gt(0) && i.gte(minInvest.value)) {
            let a = new BigNumber(maxInvestAmount.value);
            if (i.gt(a)) {
                investAmount.value = a.toNumber().toFixed(0);
                investAmountRef.value.forceUpdateValue(a.toNumber().toFixed(0));
                await nextTick();
            }
        }

        await onCredit1MaxButtonClick();
    });
};

const onPassword2Confirmed = async (pwd2) => {
    password2.value = pwd2;
    await submitForm();
};

const submitForm = async () => {
    if (!busy.value) {
        try {
            busy.value = true;

            let fd = new FormData();
            fd.set('buy_in_amount', investAmount.value);
            fd.set('credit_1_amount', credit1Amount.value);
            fd.set('credit_2_amount', credit2Amount.value);
            fd.set('current_password2', password2.value);
            fd.set('code', plan.value.code);

            const data = await axios.post('/plan_invest/submit_form', fd);

            await $helper.alertSuccess({
                message: data.message,
                callback: async () => {
                    await $userStore.fetchAccount();
                    await $router.push({name: 'user.portfolio.home'});
                }
            });
        } catch (e) {
            if (typeof e.response.data.errors !== 'undefined') {
                password2.value = '';
                password2Prompt.value = false;
            }
        } finally {
            busy.value = false;
        }
    }
}

onMounted(async () => {
    try {
        const data = await axios.post('/plan_invest/build_form', {
            code: $route.params.code
        });

        plan.value = {...data.model};
        minInvest.value = new BigNumber(data.min_invest);

        await $userStore.fetchAccount();

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
